Index: src/main/groovy/org/gradle/groovy/scripts/DefaultScriptCompilationHandler.java
===================================================================
--- src/main/groovy/org/gradle/groovy/scripts/DefaultScriptCompilationHandler.java	(revision 1596)
+++ src/main/groovy/org/gradle/groovy/scripts/DefaultScriptCompilationHandler.java	(working copy)
@@ -1,143 +1,146 @@
-/*
- * Copyright 2007-2008 the original author or authors.
- *
- * Licensed under the Apache License, Version 2.0 (the "License");
- * you may not use this file except in compliance with the License.
- * You may obtain a copy of the License at
- *
- *      http://www.apache.org/licenses/LICENSE-2.0
- *
- * Unless required by applicable law or agreed to in writing, software
- * distributed under the License is distributed on an "AS IS" BASIS,
- * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
- * See the License for the specific language governing permissions and
- * limitations under the License.
- */
-package org.gradle.groovy.scripts;
-
-import groovy.lang.Binding;
-import groovy.lang.GroovyClassLoader;
-import groovy.lang.Script;
-import org.codehaus.groovy.control.*;
-import org.codehaus.groovy.runtime.InvokerHelper;
-import org.gradle.api.GradleException;
-import org.gradle.api.GradleScriptException;
-import org.gradle.util.Clock;
-import org.gradle.util.GFileUtils;
-import org.gradle.util.WrapUtil;
-import org.slf4j.Logger;
-import org.slf4j.LoggerFactory;
-
-import java.io.File;
-import java.net.URLClassLoader;
-import java.security.CodeSource;
-
-/**
- * @author Hans Dockter
- */
-public class DefaultScriptCompilationHandler implements ScriptCompilationHandler {
-    private Logger logger = LoggerFactory.getLogger(DefaultScriptCompilationHandler.class);
-
-    private final CachePropertiesHandler cachePropertiesHandler;
-
-    public DefaultScriptCompilationHandler(CachePropertiesHandler cachePropertiesHandler) {
-        this.cachePropertiesHandler = cachePropertiesHandler;
-    }
-
-    public <T extends Script> T createScriptOnTheFly(ScriptSource source, ClassLoader classLoader,
-                                                     CompilationUnit.SourceUnitOperation transformer,
-                                                     Class<T> scriptBaseClass) {
-        Clock clock = new Clock();
-        logger.debug("Compiling script using {} with {}.", source.getDisplayName(), transformer);
-        CompilerConfiguration configuration = createBaseCompilerConfiguration(scriptBaseClass);
-        Class scriptClass = compileScript(source, classLoader, configuration, transformer);
-        T script = scriptBaseClass.cast(InvokerHelper.createScript(scriptClass, new Binding()));
-
-        logger.debug("Timing: Creating script took: {}", clock.getTime());
-        return script;
-    }
-
-    public void writeToCache(ScriptSource source, ClassLoader classLoader, File scriptCacheDir,
-                             CompilationUnit.SourceUnitOperation transformer, Class<? extends Script> scriptBaseClass) {
-        Clock clock = new Clock();
-        logger.debug("Compiling script using {} with {}.", source.getDisplayName(), transformer);
-        GFileUtils.deleteDirectory(scriptCacheDir);
-        scriptCacheDir.mkdirs();
-        CompilerConfiguration configuration = createBaseCompilerConfiguration(scriptBaseClass);
-        configuration.setTargetDirectory(scriptCacheDir);
-        compileScript(source, classLoader, configuration, transformer);
-
-        cachePropertiesHandler.writeProperties(source.getText(), scriptCacheDir);
-        logger.debug("Timing: Writing script to cache at {} took: {}", scriptCacheDir.getAbsolutePath(),
-                clock.getTime());
-    }
-
-    private Class compileScript(ScriptSource source, ClassLoader classLoader, CompilerConfiguration configuration,
-                              final CompilationUnit.SourceUnitOperation transformer) {
-        GroovyClassLoader groovyClassLoader = new GroovyClassLoader(classLoader, configuration, false) {
-            @Override
-            protected CompilationUnit createCompilationUnit(CompilerConfiguration config, CodeSource source) {
-                CompilationUnit compilationUnit = super.createCompilationUnit(config, source);
-                if (transformer != null) {
-                    compilationUnit.addPhaseOperation(transformer, Phases.CANONICALIZATION);
-                }
-                return compilationUnit;
-            }
-        };
-        String scriptText = source.getText();
-        String scriptName = source.getClassName();
-        Class scriptClass;
-        try {
-            scriptClass = groovyClassLoader.parseClass(scriptText == null ? "" : scriptText, scriptName);
-        } catch (MultipleCompilationErrorsException e) {
-            throw new GradleScriptException(String.format("Could not compile %s.", source.getDisplayName()), e, source,
-                    e.getErrorCollector().getSyntaxError(0).getLine());
-        } catch (CompilationFailedException e) {
-            throw new GradleException(String.format("Could not compile %s.", source.getDisplayName()), e);
-        }
-        if (scriptClass == null) {
-            // Assume an empty script
-            String emptySource = String.format("class %s extends %s { public Object run() { return null } }",
-                    source.getClassName(), configuration.getScriptBaseClass().replaceAll("\\$", "."));
-            scriptClass = groovyClassLoader.parseClass(emptySource, scriptName);
-        }
-        return scriptClass;
-    }
-
-    private CompilerConfiguration createBaseCompilerConfiguration(Class<? extends Script> scriptBaseClass) {
-        CompilerConfiguration configuration = new CompilerConfiguration();
-        configuration.setScriptBaseClass(scriptBaseClass.getName());
-        return configuration;
-    }
-
-    public <T extends Script> T loadFromCache(ScriptSource source, ClassLoader classLoader, File scriptCacheDir,
-                                              Class<T> scriptBaseClass) {
-        String scriptText = source.getText();
-        String scriptName = source.getClassName();
-        CachePropertiesHandler.CacheState cacheState = cachePropertiesHandler.getCacheState(scriptText, scriptCacheDir);
-        if (cacheState == CachePropertiesHandler.CacheState.INVALID) {
-            return null;
-        }
-        Clock clock = new Clock();
-        Script script;
-        try {
-            URLClassLoader urlClassLoader = new URLClassLoader(WrapUtil.toArray(scriptCacheDir.toURI().toURL()),
-                    classLoader);
-            script = (Script) urlClassLoader.loadClass(scriptName).newInstance();
-        } catch (ClassNotFoundException e) {
-            logger.debug("Class not in cache: ", e);
-            return null;
-        } catch (Exception e) {
-            throw new GradleException(e);
-        }
-        if (!scriptBaseClass.isInstance(script)) {
-            return null;
-        }
-        logger.debug("Timing: Loading script from cache took: {}", clock.getTime());
-        return scriptBaseClass.cast(script);
-    }
-
-    public CachePropertiesHandler getCachePropertyHandler() {
-        return cachePropertiesHandler;
-    }
-}
+/*
+ * Copyright 2007-2008 the original author or authors.
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+package org.gradle.groovy.scripts;
+
+import groovy.lang.Binding;
+import groovy.lang.GroovyClassLoader;
+import groovy.lang.Script;
+import org.codehaus.groovy.control.*;
+import org.codehaus.groovy.runtime.InvokerHelper;
+import org.gradle.api.GradleException;
+import org.gradle.api.GradleScriptException;
+import org.gradle.util.Clock;
+import org.gradle.util.GFileUtils;
+import org.gradle.util.WrapUtil;
+import org.slf4j.Logger;
+import org.slf4j.LoggerFactory;
+
+import java.io.File;
+import java.net.URLClassLoader;
+import java.security.CodeSource;
+import java.util.List;
+
+/**
+ * @author Hans Dockter
+ */
+public class DefaultScriptCompilationHandler implements ScriptCompilationHandler {
+    private Logger logger = LoggerFactory.getLogger(DefaultScriptCompilationHandler.class);
+
+    private final CachePropertiesHandler cachePropertiesHandler;
+
+    public DefaultScriptCompilationHandler(CachePropertiesHandler cachePropertiesHandler) {
+        this.cachePropertiesHandler = cachePropertiesHandler;
+    }
+
+    public <T extends Script> T createScriptOnTheFly(ScriptSource source, ClassLoader classLoader,
+                                                     List transformers,
+                                                     Class<T> scriptBaseClass) {
+        Clock clock = new Clock();
+        logger.debug("Compiling script on the fly using {} with {}.", source.getDisplayName(), transformers);
+        CompilerConfiguration configuration = createBaseCompilerConfiguration(scriptBaseClass);
+        Class scriptClass = compileScript(source, classLoader, configuration, transformers);
+        T script = scriptBaseClass.cast(InvokerHelper.createScript(scriptClass, new Binding()));
+
+        logger.debug("Timing: Creating script took: {}", clock.getTime());
+        return script;
+    }
+
+    public void writeToCache(ScriptSource source, ClassLoader classLoader, File scriptCacheDir,
+                             List transformers, Class<? extends Script> scriptBaseClass) {
+        Clock clock = new Clock();
+        logger.debug("Compiling script to cache using {} with {}.", source.getDisplayName(), transformers);
+        GFileUtils.deleteDirectory(scriptCacheDir);
+        scriptCacheDir.mkdirs();
+        CompilerConfiguration configuration = createBaseCompilerConfiguration(scriptBaseClass);
+        configuration.setTargetDirectory(scriptCacheDir);
+        compileScript(source, classLoader, configuration, transformers);
+
+        cachePropertiesHandler.writeProperties(source, scriptCacheDir);
+        logger.debug("Timing: Writing script to cache at {} took: {}", scriptCacheDir.getAbsolutePath(),
+                clock.getTime());
+    }
+
+    private Class compileScript(ScriptSource source, ClassLoader classLoader, CompilerConfiguration configuration,
+                              final List transformers) {
+        GroovyClassLoader groovyClassLoader = new GroovyClassLoader(classLoader, configuration, false) {
+            @Override
+            protected CompilationUnit createCompilationUnit(CompilerConfiguration config, CodeSource source) {
+                CompilationUnit compilationUnit = super.createCompilationUnit(config, source);
+                for (Object transformer : transformers) {
+                    if (transformer instanceof CompilationUnit.SourceUnitOperation)
+                        compilationUnit.addPhaseOperation((CompilationUnit.SourceUnitOperation)transformer, Phases.CANONICALIZATION);
+                    else if (transformer instanceof CompilationUnit.PrimaryClassNodeOperation)
+                        compilationUnit.addPhaseOperation((CompilationUnit.PrimaryClassNodeOperation)transformer, Phases.CANONICALIZATION);
+                }
+                return compilationUnit;
+            }
+        };
+        String scriptText = source.getText();
+        String scriptName = source.getClassName();
+        Class scriptClass;
+        try {
+            scriptClass = groovyClassLoader.parseClass(scriptText == null ? "" : scriptText, scriptName);
+        } catch (MultipleCompilationErrorsException e) {
+            throw new GradleScriptException(String.format("Could not compile %s.", source.getDisplayName()), e, source,
+                    e.getErrorCollector().getSyntaxError(0).getLine());
+        } catch (CompilationFailedException e) {
+            throw new GradleException(String.format("Could not compile %s.", source.getDisplayName()), e);
+        }
+        if (scriptClass == null) {
+            // Assume an empty script
+            String emptySource = String.format("class %s extends %s { public Object run() { return null } }",
+                    source.getClassName(), configuration.getScriptBaseClass().replaceAll("\\$", "."));
+            scriptClass = groovyClassLoader.parseClass(emptySource, scriptName);
+        }
+        return scriptClass;
+    }
+
+    private CompilerConfiguration createBaseCompilerConfiguration(Class<? extends Script> scriptBaseClass) {
+        CompilerConfiguration configuration = new CompilerConfiguration();
+        configuration.setScriptBaseClass(scriptBaseClass.getName());
+        return configuration;
+    }
+
+    public <T extends Script> T loadFromCache(ScriptSource source, ClassLoader classLoader, File scriptCacheDir,
+                                              Class<T> scriptBaseClass) {
+        CachePropertiesHandler.CacheState cacheState = cachePropertiesHandler.getCacheState(source, scriptCacheDir);
+        if (cacheState == CachePropertiesHandler.CacheState.INVALID) {
+            return null;
+        }
+        Clock clock = new Clock();
+        Script script;
+        try {
+            URLClassLoader urlClassLoader = new URLClassLoader(WrapUtil.toArray(scriptCacheDir.toURI().toURL()),
+                    classLoader);
+            String scriptName = source.getClassName();
+            script = (Script) urlClassLoader.loadClass(scriptName).newInstance();
+        } catch (ClassNotFoundException e) {
+            logger.debug("Class not in cache: ", e);
+            return null;
+        } catch (Exception e) {
+            throw new GradleException(e);
+        }
+        if (!scriptBaseClass.isInstance(script)) {
+            return null;
+        }
+        logger.debug("Timing: Loading script from cache took: {}", clock.getTime());
+        return scriptBaseClass.cast(script);
+    }
+
+    public CachePropertiesHandler getCachePropertyHandler() {
+        return cachePropertiesHandler;
+    }
+}
Index: src/main/groovy/org/gradle/groovy/scripts/DefaultScriptProcessorFactory.java
===================================================================
--- src/main/groovy/org/gradle/groovy/scripts/DefaultScriptProcessorFactory.java	(revision 1596)
+++ src/main/groovy/org/gradle/groovy/scripts/DefaultScriptProcessorFactory.java	(working copy)
@@ -1,112 +1,133 @@
-/*
- * Copyright 2007-2008 the original author or authors.
- *
- * Licensed under the Apache License, Version 2.0 (the "License");
- * you may not use this file except in compliance with the License.
- * You may obtain a copy of the License at
- *
- *      http://www.apache.org/licenses/LICENSE-2.0
- *
- * Unless required by applicable law or agreed to in writing, software
- * distributed under the License is distributed on an "AS IS" BASIS,
- * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
- * See the License for the specific language governing permissions and
- * limitations under the License.
- */
-package org.gradle.groovy.scripts;
-
-import org.codehaus.groovy.control.CompilationUnit;
-import org.gradle.CacheUsage;
-import org.gradle.api.Project;
-
-import java.io.File;
-
-/**
- * @author Hans Dockter
- */
-public class DefaultScriptProcessorFactory implements ScriptProcessorFactory {
-    private ScriptCompilationHandler scriptCompilationHandler;
-    private final CacheUsage cacheUsage;
-
-    public DefaultScriptProcessorFactory(ScriptCompilationHandler scriptCompilationHandler, CacheUsage cacheUsage) {
-        this.scriptCompilationHandler = scriptCompilationHandler;
-        this.cacheUsage = cacheUsage;
-    }
-
-    public ScriptProcessor createProcessor(ScriptSource source) {
-        return new ScriptProcessorImpl(source);
-    }
-
-
-    private boolean isCacheable(File sourceFile) {
-        return cacheUsage != CacheUsage.OFF && sourceFile != null && sourceFile.isFile();
-    }
-
-    public ScriptCompilationHandler getScriptCacheHandler() {
-        return scriptCompilationHandler;
-    }
-
-    public CacheUsage getCacheUsage() {
-        return cacheUsage;
-    }
-
-    private class ScriptProcessorImpl implements ScriptProcessor {
-        private final ScriptSource source;
-        private ClassLoader classloader;
-        private CompilationUnit.SourceUnitOperation transformer;
-
-        public ScriptProcessorImpl(ScriptSource source) {
-            this.source = source;
-        }
-
-        public ScriptProcessor setClassloader(ClassLoader classloader) {
-            this.classloader = classloader;
-            return this;
-        }
-
-        public ScriptProcessor setTransformer(CompilationUnit.SourceUnitOperation transformer) {
-            this.transformer = transformer;
-            return this;
-        }
-
-        public <T extends ScriptWithSource> T process(Class<T> scriptType) {
-            ClassLoader classloader = this.classloader != null ? this.classloader : Thread.currentThread().getContextClassLoader();
-
-            File sourceFile = source.getSourceFile();
-            T script;
-            if (isCacheable(sourceFile)) {
-                script = loadViaCache(classloader, scriptType);
-            }
-            else {
-                script = loadWithoutCache(classloader, scriptType);
-            }
-            script.setScriptSource(source);
-            return script;
-        }
-
-        private <T extends ScriptWithSource> T loadWithoutCache(ClassLoader classLoader, Class<T> scriptBaseClass) {
-            return scriptCompilationHandler.createScriptOnTheFly(source, classLoader, transformer, scriptBaseClass);
-        }
-
-        private <T extends ScriptWithSource> T loadViaCache(ClassLoader classLoader, Class<T> scriptBaseClass) {
-            File sourceFile = source.getSourceFile();
-            File cacheDir = new File(sourceFile.getParentFile(), Project.CACHE_DIR_NAME);
-            File scriptCacheDir = new File(cacheDir, sourceFile.getName());
-            if (transformer != null) {
-                scriptCacheDir = new File(scriptCacheDir, transformer.getClass().getSimpleName());
-            }
-            else {
-                scriptCacheDir = new File(scriptCacheDir, "NoTransformer");
-            }
-            
-            if (cacheUsage == CacheUsage.ON) {
-                T cachedScript = scriptCompilationHandler.loadFromCache(source, classLoader, scriptCacheDir, scriptBaseClass);
-                if (cachedScript != null) {
-                    return cachedScript;
-                }
-            }
-            scriptCompilationHandler.writeToCache(source, classLoader, scriptCacheDir, transformer, scriptBaseClass);
-            return scriptCompilationHandler.loadFromCache(source, classLoader, scriptCacheDir, scriptBaseClass);
-        }
-    }
-}
+/*
+ * Copyright 2007-2008 the original author or authors.
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+package org.gradle.groovy.scripts;
+
+import org.codehaus.groovy.control.CompilationUnit;
+import org.gradle.CacheUsage;
+import org.gradle.api.Project;
+
+import java.io.File;
+import java.util.List;
+import java.util.ArrayList;
+import java.util.Iterator;
+
+/**
+ * @author Hans Dockter
+ */
+public class DefaultScriptProcessorFactory implements ScriptProcessorFactory {
+    private ScriptCompilationHandler scriptCompilationHandler;
+    private final CacheUsage cacheUsage;
+
+    public DefaultScriptProcessorFactory(ScriptCompilationHandler scriptCompilationHandler, CacheUsage cacheUsage) {
+        this.scriptCompilationHandler = scriptCompilationHandler;
+        this.cacheUsage = cacheUsage;
+    }
+
+    public ScriptProcessor createProcessor(ScriptSource source) {
+        return new ScriptProcessorImpl(source);
+    }
+
+
+    private boolean isCacheable(File sourceFile) {
+        return cacheUsage != CacheUsage.OFF && sourceFile != null && sourceFile.isFile();
+    }
+
+    public ScriptCompilationHandler getScriptCacheHandler() {
+        return scriptCompilationHandler;
+    }
+
+    public CacheUsage getCacheUsage() {
+        return cacheUsage;
+    }
+
+    private class ScriptProcessorImpl implements ScriptProcessor {
+        private final ScriptSource source;
+        private ClassLoader classloader;
+        private final List transformers = new ArrayList();
+
+        public ScriptProcessorImpl(ScriptSource source) {
+            this.source = source;
+        }
+
+        public ScriptProcessor setClassloader(ClassLoader classloader) {
+            this.classloader = classloader;
+            return this;
+        }
+
+        public ScriptProcessor clearTransformers() {
+            transformers.clear();
+            return this;
+        }
+
+        public ScriptProcessor addTransformer(CompilationUnit.SourceUnitOperation transformer) {
+            assert transformer != null;
+            transformers.add(transformer);
+            return this;
+        }
+
+        public ScriptProcessor addTransformer(CompilationUnit.PrimaryClassNodeOperation transformer) {
+            assert transformer != null;
+            transformers.add(transformer);
+            return this;
+        }
+
+        public <T extends ScriptWithSource> T process(Class<T> scriptType) {
+            ClassLoader classloader = this.classloader != null ? this.classloader : Thread.currentThread().getContextClassLoader();
+
+            File sourceFile = source.getSourceFile();
+            T script;
+            if (isCacheable(sourceFile)) {
+                script = loadViaCache(classloader, scriptType);
+            }
+            else {
+                script = loadWithoutCache(classloader, scriptType);
+            }
+            script.setScriptSource(source);
+            return script;
+        }
+
+        private <T extends ScriptWithSource> T loadWithoutCache(ClassLoader classLoader, Class<T> scriptBaseClass) {
+            return scriptCompilationHandler.createScriptOnTheFly(source, classLoader, transformers, scriptBaseClass);
+        }
+
+        private <T extends ScriptWithSource> T loadViaCache(ClassLoader classLoader, Class<T> scriptBaseClass) {
+            File sourceFile = source.getSourceFile();
+            File cacheDir = new File(sourceFile.getParentFile(), Project.CACHE_DIR_NAME);
+            File scriptCacheDir = new File(cacheDir, sourceFile.getName());
+            if (!transformers.isEmpty()) {
+                StringBuilder transformerNameBuilder = new StringBuilder();
+                for (Iterator it = transformers.iterator(); it.hasNext();) {
+                    transformerNameBuilder.append(it.next().getClass().getSimpleName());
+                    if (it.hasNext())
+                        transformerNameBuilder.append('-');
+                }
+                scriptCacheDir = new File(scriptCacheDir, transformerNameBuilder.toString());
+            }
+            else {
+                scriptCacheDir = new File(scriptCacheDir, "NoTransformer");
+            }
+            
+            if (cacheUsage == CacheUsage.ON) {
+                T cachedScript = scriptCompilationHandler.loadFromCache(source, classLoader, scriptCacheDir, scriptBaseClass);
+                if (cachedScript != null) {
+                    return cachedScript;
+                }
+            }
+            scriptCompilationHandler.writeToCache(source, classLoader, scriptCacheDir, transformers, scriptBaseClass);
+            return scriptCompilationHandler.loadFromCache(source, classLoader, scriptCacheDir, scriptBaseClass);
+        }
+    }
+}
Index: src/main/groovy/org/gradle/groovy/scripts/FileScriptSource.java
===================================================================
--- src/main/groovy/org/gradle/groovy/scripts/FileScriptSource.java	(revision 1596)
+++ src/main/groovy/org/gradle/groovy/scripts/FileScriptSource.java	(working copy)
@@ -1,66 +1,83 @@
-/*
- * Copyright 2008 the original author or authors.
- *
- * Licensed under the Apache License, Version 2.0 (the "License");
- * you may not use this file except in compliance with the License.
- * You may obtain a copy of the License at
- *
- *      http://www.apache.org/licenses/LICENSE-2.0
- *
- * Unless required by applicable law or agreed to in writing, software
- * distributed under the License is distributed on an "AS IS" BASIS,
- * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
- * See the License for the specific language governing permissions and
- * limitations under the License.
- */
-package org.gradle.groovy.scripts;
-
-import org.gradle.util.GFileUtils;
-
-import java.io.File;
-
-/**
- * A {@link ScriptSource} which loads the script from a file.
- */
-public class FileScriptSource implements ScriptSource {
-    private final String description;
-    private final File sourceFile;
-
-    public FileScriptSource(String description, File sourceFile) {
-        this.description = description;
-        this.sourceFile = sourceFile;
-    }
-
-    public String getText() {
-        if (!sourceFile.exists()) {
-            return "";
-        }
-        return GFileUtils.readFileToString(sourceFile);
-    }
-
-    public String getClassName() {
-        String name = sourceFile.getName();
-        StringBuilder className = new StringBuilder();
-        for (int i = 0; i < name.length(); i++) {
-            char ch = name.charAt(i);
-            if (Character.isJavaIdentifierPart(ch)) {
-                className.append(ch);
-            }
-            else {
-                className.append('_');
-            }
-        }
-        if (!Character.isJavaIdentifierStart(className.charAt(0))) {
-            className.insert(0, '_');
-        }
-        return className.toString();
-    }
-
-    public File getSourceFile() {
-        return sourceFile;
-    }
-
-    public String getDisplayName() {
-        return String.format("%s '%s'", description, sourceFile.getAbsolutePath());
-    }
-}
+/*
+ * Copyright 2008 the original author or authors.
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+package org.gradle.groovy.scripts;
+
+import org.gradle.util.GFileUtils;
+
+import java.io.File;
+import java.io.IOException;
+
+/**
+ * A {@link ScriptSource} which loads the script from a file.
+ */
+public class FileScriptSource implements ScriptSource {
+    private final String description;
+    private final File sourceFile;
+
+    public FileScriptSource(String description, File sourceFile) {
+        this.description = description;
+        this.sourceFile = sourceFile;
+    }
+
+    public String getText() {
+        if (!sourceFile.exists()) {
+            return "";
+        }
+        return GFileUtils.readFileToString(sourceFile);
+    }
+
+    public String getClassName() {
+        String name = sourceFile.getName();
+        StringBuilder className = new StringBuilder();
+        for (int i = 0; i < name.length(); i++) {
+            char ch = name.charAt(i);
+            if (Character.isJavaIdentifierPart(ch)) {
+                className.append(ch);
+            }
+            else {
+                className.append('_');
+            }
+        }
+        if (!Character.isJavaIdentifierStart(className.charAt(0))) {
+            className.insert(0, '_');
+        }
+        return className.toString();
+    }
+
+    public File getSourceFile() {
+        return sourceFile;
+    }
+
+    public String getSourceFileCanonicalPath()
+    {
+        String path = null;
+        if (sourceFile != null)
+        {
+            try {
+                path = sourceFile.getCanonicalPath();
+            } catch (IOException ignored) {
+                // can't get the canonical path, use the absolute path as a fallback
+                path = sourceFile.getAbsolutePath();
+            }
+        }
+
+        return path;
+    }
+    
+    public String getDisplayName() {
+        return String.format("%s '%s'", description, sourceFile.getAbsolutePath());
+    }
+}
